<?php

defined('_JEXEC') or die();

class pm_levipay extends PaymentRoot{
    
    function showPaymentForm($params, $pmconfigs)
	{
        include(dirname(__FILE__) . '/paymentform.php');
    }

	function showAdminFormParams($params)
	{
		$jmlThisDocument = &JFactory::getDocument();
		$pm_method = $this->getPmMethod();
		$hosturl = JURI::root();
		
		if ($jmlThisDocument->language == 'en-gb')
		{
			include(JPATH_SITE . '/administrator/components/com_jshopping/lang/en-GB_levipay.php');
		}
		else
		{
			include(JPATH_SITE . '/administrator/components/com_jshopping/lang/ru-RU_levipay.php');
		}
		
		$array_params = array(
			'merchant_url',
			'merchant_id',
			'secret_key1',
            'secret_key2',
			'log_file',
			'ip_filter',
			'email_err',
			'transaction_end_status',
			'transaction_pending_status',
			'transaction_failed_status',
			'success_url',
			'fail_url',
			'status_url'
		);
		
		if (!isset($params['merchant_url']) || empty($params['merchant_url']))
		{
			$params['merchant_url'] = 'https://levipay.com/pay/';
		}
		
		$params['success_url'] = $hosturl . 'index.php?option=com_jshopping&controller=checkout&task=step7&act=return&js_paymentclass=' . $pm_method->payment_class;
		$params['fail_url'] = $hosturl . 'index.php?option=com_jshopping&controller=checkout&task=step7&act=cancel&js_paymentclass=' . $pm_method->payment_class;
		$params['status_url'] = $hosturl . 'index.php?option=com_jshopping&controller=checkout&task=step7&act=notify&js_paymentclass=' . $pm_method->payment_class;

		foreach ($array_params as $key)
		{
			if (!isset($params[$key]))
			{
				$params[$key] = '';
			}
		}

		$orders = JSFactory::getModel('orders', 'JshoppingModel');
		include(dirname(__FILE__) . '/adminparamsform.php');
	}

	function checkTransaction($pmconfigs, $order, $act)
	{
        $jshopConfig = JSFactory::getConfig();
		$request = JFactory::getApplication()->input->getArray();

		$jmlThisDocument = &JFactory::getDocument();
		
		if (isset($request['intid']) && isset($request['SIGN']))
		{
			$err = false;
			$message = '';
			
			if ($jmlThisDocument->language == 'en-gb')
			{
				include(JPATH_SITE . '/administrator/components/com_jshopping/lang/en-GB_levipay.php');
			}
			else
			{
				include(JPATH_SITE . '/administrator/components/com_jshopping/lang/ru-RU_levipay.php');
			}
			
			// запись логов

            $log_text =
                "--------------------------------------------------------\n" .
                "id you	shoop   	" . $request["MERCHANT_ID"] . "\n" .
                "amount				" . $request["AMOUNT"] . "\n" .
                "kassa operation id " . $request["intid"] . "\n" .
                "mercant order id	" . $request["MERCHANT_ORDER_ID"] . "\n" .
                "e-mail client		" . $request["P_EMAIL"] . "\n" .
                "phone client    	" . $request["P_PHONE"] . "\n" .
                "currency			" . $request["CUR_ID"] . "\n" .
                "sign				" . $request["SIGN"] . "\n\n";
			
			$log_file = $pmconfigs['log_file'];
			
			if (!empty($log_file))
			{
				file_put_contents($_SERVER['DOCUMENT_ROOT'] . $log_file, $log_text, FILE_APPEND);
			}
			
			// проверка ip

			$sign_hash = md5( implode(":", array(
				$request['MERCHANT_ID'],
				$request['AMOUNT'],
				$pmconfigs['secret_key2'],
				$request['MERCHANT_ORDER_ID']

			)));

            $valid_ip = true;
            $sIP = str_replace(' ', '', $pmconfigs['ip_filter']);

            if (!empty($sIP)) {

                $ip_filter_arr = explode(',', $sIP);

                $this_ip  = (isset($_SERVER['HTTP_X_REAL_IP'])) ? $_SERVER['HTTP_X_REAL_IP'] : $_SERVER['REMOTE_ADDR'];

                foreach ( $ip_filter_arr as $key => $value ) {
                    $ip_filter_arr[ $key ] = ip2long( $value );
                }

                if ( ! in_array( ip2long( $this_ip ), $ip_filter_arr ) ) {
                    $valid_ip = false;
                }
            }
			
			if (!$valid_ip)
			{
				$message .= _JSHOP_LEVIPAY_MSG_NOT_VALID_IP . "\n" .
				_JSHOP_LEVIPAY_MSG_VALID_IP . $sIP . "\n" .
				_JSHOP_LEVIPAY_MSG_THIS_IP . $_SERVER['REMOTE_ADDR'] . "\n";
				$err = true;
			}


            if (!$err) {

                $order_curr = strtoupper($order->currency_code_iso);
                $order_curr = ($order_curr == 'RUR') ? 'RUB' : $order_curr;
                $order_amount = number_format($order->order_total, 2, '.', '');

                // проверка суммы и валюты

                if ($request['AMOUNT'] != $order_amount) {

                    $message .= _JSHOP_LEVIPAY_MSG_WRONG_AMOUNT . "\n";
                    $err = true;
                }

                // проверка статуса
				
				if (!$err) {

					if ($request['SIGN'] == $sign_hash) {

                        echo 'YES';

                        if ($order->order_status != $pmconfigs['transaction_end_status']) {

                            return array(1, $request['MERCHANT_ORDER_ID']);
                        }
                        else {

                                return false;
                        }

                    }
                    else {

                        $message .= _JSHOP_LEVIPAY_MSG_HASHES_NOT_EQUAL . "\n";
                        $err = true;
                    }
				}
			}
			
			if ($err)
			{
				$to = $pmconfigs['email_err'];

				if (!empty($to))
				{
					$message = _JSHOP_LEVIPAY_MSG_ERR_REASONS . "\n\n" . $message . "\n" . $log_text;
					$headers = "From: no-reply@" . $_SERVER['HTTP_HOST'] . "\r\n" . 
					"Content-type: text/plain; charset=utf-8 \r\n";
					mail($to, _JSHOP_LEVIPAY_MSG_SUBJECT, $message, $headers);
				}
				echo $request['MERCHANT_ORDER_ID'] . '|error|' . $message;
				return array(3, $request['MERCHANT_ORDER_ID']);
			}
		}
	}

	function showEndForm($pmconfigs, $order)
	{
		$jshopConfig = JSFactory::getConfig();
		
		$m_url = $pmconfigs['merchant_url'];
		$m_shop = $pmconfigs['merchant_id'];
		$m_orderid = $order->order_id;
		$m_amount = number_format($order->order_total, 2, '.', '');
		$m_curr = strtoupper($order->currency_code_iso);
		$m_curr = ($m_curr == 'RUR') ? 'RUB' : $m_curr;
		$m_key = $pmconfigs['secret_key1'];

		if (empty($_REQUEST['lang']))
		{
            $m_lang = 'ru';
		}
        else
		{
            $m_lang = $_REQUEST['lang'];
		}

		$arHash = array(
			$m_shop,
			$m_amount,
            $m_key,
			$m_orderid
		);
		
		$sign = md5( implode(':', $arHash));
?>
		<html>
			<head>
				<meta http-equiv="content-type" content="text/html; charset=UTF-8" />          
			</head>        
			<body>
				<form action="<?php echo $m_url; ?>" id="paymentform" name="paymentform" method="GET">
					<input type="hidden" name="m" value="<?php echo $m_shop; ?>">
					<input type="hidden" name="oa" value="<?php echo $m_amount; ?>">
					<input type="hidden" name="o" value="<?php echo $m_orderid; ?>">
					<input type="hidden" name="s" value="<?php echo $sign; ?>">
					<input type="hidden" name="lang" value="<?php echo $m_lang; ?>">
				</form>
				<?php print _JSHOP_REDIRECT_TO_PAYMENT_PAGE ?>
				<br>
				<script type="text/javascript">document.getElementById('paymentform').submit();</script>
			</body>
        </html>
<?php
        die();
	}
    
    function getUrlParams($pmconfigs){

        $params = array();
        $params['order_id'] = JFactory::getApplication()->input->getInt('MERCHANT_ORDER_ID');
        $params['hash'] = "";
        $params['checkHash'] = 0;
        $params['checkReturnParams'] = $pmconfigs['checkdatareturn'];
		return $params;
    }
}